Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## edu.emory.mathcs.backport.java.util
Interface NavigableMap

All Superinterfaces:
  java.util.Map, java.util.SortedMap

All Known Subinterfaces:
  ConcurrentNavigableMap

All Known Implementing Classes:
  ConcurrentSkipListMap, TreeMap

public interface NavigableMap
extends java.util.SortedMap

A `SortedMap` extended with navigation methods returning the closest matches for given search targets. Methods , , , and return objects associated with keys respectively less than, less than or equal, greater than or equal, and greater than a given key, returning if there is no such key. Similarly, methods , , , and return only the associated keys. All of these methods are designed for locating, not traversing entries.

A may be accessed and traversed in either ascending or descending key order. The method returns a view of the map with the senses of all relational and directional methods inverted. The performance of ascending operations and views is likely to be faster than that of descending ones. Methods , , and differ from the like-named methods in accepting additional arguments describing whether lower and upper bounds are inclusive versus exclusive. Submaps of any must implement the interface.

This interface additionally defines methods , , , and that return and/or remove the least and greatest mappings, if any exist, else returning .

Implementations of entry-returning methods are expected to return pairs representing snapshots of mappings at the time they were produced, and thus generally do not support the optional method. Note however that it is possible to change mappings in the associated map using method .

Methods `subMap(K, K)`, `headMap(K)`, and `tailMap(K)` are specified to return to allow existing implementations of to be compatibly retrofitted to implement , but extensions and implementations of this interface are encouraged to override these methods to return . Similarly, `Map.keySet()` can be overriden to return .

This interface is a member of the Java Collections Framework.

Since:
  1.6
Author:
  Doug Lea, Josh Bloch

Nested Class Summary

Nested classes inherited from class java.util.Map
`java.util.Map.Entry`

Method Summary
`java.util.Map.Entry` | `ceilingEntry(java.lang.Object key)` Returns a key-value mapping associated with the least key greater than or equal to the given key, or if there is no such key.
`java.lang.Object` | `ceilingKey(java.lang.Object key)` Returns the least key greater than or equal to the given key, or if there is no such key.
`NavigableSet` | `descendingKeySet()` Returns a reverse order `NavigableSet` view of the keys contained in this map.
`NavigableMap` | `descendingMap()` Returns a reverse order view of the mappings contained in this map.
`java.util.Map.Entry` | `firstEntry()` Returns a key-value mapping associated with the least key in this map, or if the map is empty.
`java.util.Map.Entry` | `floorEntry(java.lang.Object key)` Returns a key-value mapping associated with the greatest key less than or equal to the given key, or if there is no such key.
`java.lang.Object` | `floorKey(java.lang.Object key)` Returns the greatest key less than or equal to the given key, or if there is no such key.
`java.util.SortedMap` | `headMap(java.lang.Object toKey)`
`NavigableMap` | `headMap(java.lang.Object toKey, boolean inclusive)` Returns a view of the portion of this map whose keys are less than (or equal to, if is true) .
`java.util.Map.Entry` | `higherEntry(java.lang.Object key)` Returns a key-value mapping associated with the least key strictly greater than the given key, or if there is no such key.
`java.lang.Object` | `higherKey(java.lang.Object key)` Returns the least key strictly greater than the given key, or if there is no such key.
`java.util.Map.Entry` | `lastEntry()` Returns a key-value mapping associated with the greatest key in this map, or if the map is empty.
`java.util.Map.Entry` | `lowerEntry(java.lang.Object key)` Returns a key-value mapping associated with the greatest key strictly less than the given key, or if there is no such key.
`java.lang.Object` | `lowerKey(java.lang.Object key)` Returns the greatest key strictly less than the given key, or if there is no such key.
`NavigableSet` | `navigableKeySet()` Returns a `NavigableSet` view of the keys contained in this map.
`java.util.Map.Entry` | `pollFirstEntry()` Removes and returns a key-value mapping associated with the least key in this map, or if the map is empty.
`java.util.Map.Entry` | `pollLastEntry()` Removes and returns a key-value mapping associated with the greatest key in this map, or if the map is empty.
`NavigableMap` | `subMap(java.lang.Object fromKey, boolean fromInclusive, java.lang.Object toKey, boolean toInclusive)` Returns a view of the portion of this map whose keys range from to .
`java.util.SortedMap` | `subMap(java.lang.Object fromKey, java.lang.Object toKey)`
`java.util.SortedMap` | `tailMap(java.lang.Object fromKey)`
`NavigableMap` | `tailMap(java.lang.Object fromKey, boolean inclusive)` Returns a view of the portion of this map whose keys are greater than (or equal to, if is true) .

Methods inherited from interface java.util.SortedMap
`comparator, firstKey, lastKey`

Methods inherited from interface java.util.Map
`clear, containsKey, containsValue, entrySet, equals, get, hashCode, isEmpty, keySet, put, putAll, remove, size, values`

Method Detail

### lowerEntry

    public java.util.Map.Entry lowerEntry(java.lang.Object key)

  Returns a key-value mapping associated with the greatest key strictly less than the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    an entry with the greatest key less than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### lowerKey

    public java.lang.Object lowerKey(java.lang.Object key)

  Returns the greatest key strictly less than the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    the greatest key less than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### floorEntry

    public java.util.Map.Entry floorEntry(java.lang.Object key)

  Returns a key-value mapping associated with the greatest key less than or equal to the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    an entry with the greatest key less than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### floorKey

    public java.lang.Object floorKey(java.lang.Object key)

  Returns the greatest key less than or equal to the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    the greatest key less than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### ceilingEntry

    public java.util.Map.Entry ceilingEntry(java.lang.Object key)

  Returns a key-value mapping associated with the least key greater than or equal to the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    an entry with the least key greater than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### ceilingKey

    public java.lang.Object ceilingKey(java.lang.Object key)

  Returns the least key greater than or equal to the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    the least key greater than or equal to , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### higherEntry

    public java.util.Map.Entry higherEntry(java.lang.Object key)

  Returns a key-value mapping associated with the least key strictly greater than the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    an entry with the least key greater than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### higherKey

    public java.lang.Object higherKey(java.lang.Object key)

  Returns the least key strictly greater than the given key, or if there is no such key.

  Parameters:
    `key` - the key
  Returns:
    the least key greater than , or if there is no such key
  Throws:
    `java.lang.ClassCastException` - if the specified key cannot be compared with the keys currently in the map
    `java.lang.NullPointerException` - if the specified key is null and this map does not permit null keys

### firstEntry

    public java.util.Map.Entry firstEntry()

  Returns a key-value mapping associated with the least key in this map, or if the map is empty.

  Returns:
    an entry with the least key, or if this map is empty

### lastEntry

    public java.util.Map.Entry lastEntry()

  Returns a key-value mapping associated with the greatest key in this map, or if the map is empty.

  Returns:
    an entry with the greatest key, or if this map is empty

### pollFirstEntry

    public java.util.Map.Entry pollFirstEntry()

  Removes and returns a key-value mapping associated with the least key in this map, or if the map is empty.

  Returns:
    the removed first entry of this map, or if this map is empty

### pollLastEntry

    public java.util.Map.Entry pollLastEntry()

  Removes and returns a key-value mapping associated with the greatest key in this map, or if the map is empty.

  Returns:
    the removed last entry of this map, or if this map is empty

### descendingMap

    public NavigableMap descendingMap()

  Returns a reverse order view of the mappings contained in this map. The descending map is backed by this map, so changes to the map are reflected in the descending map, and vice-versa. If either map is modified while an iteration over a collection view of either map is in progress (except through the iterator's own operation), the results of the iteration are undefined.

  The returned map has an ordering equivalent to ``Collections.reverseOrder`(comparator())`. The expression returns a view of essentially equivalent to .

  Returns:
    a reverse order view of this map

### navigableKeySet

    public NavigableSet navigableKeySet()

  Returns a `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in ascending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the , , , , and operations. It does not support the or operations.

  Returns:
    a navigable set view of the keys in this map

### descendingKeySet

    public NavigableSet descendingKeySet()

  Returns a reverse order `NavigableSet` view of the keys contained in this map. The set's iterator returns the keys in descending order. The set is backed by the map, so changes to the map are reflected in the set, and vice-versa. If the map is modified while an iteration over the set is in progress (except through the iterator's own operation), the results of the iteration are undefined. The set supports element removal, which removes the corresponding mapping from the map, via the , , , , and operations. It does not support the or operations.

  Returns:
    a reverse order navigable set view of the keys in this map

### subMap

    public NavigableMap subMap(java.lang.Object fromKey,
                               boolean fromInclusive,
                               java.lang.Object toKey,
                               boolean toInclusive)

  Returns a view of the portion of this map whose keys range from to . If and are equal, the returned map is empty unless and are both true. The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

  The returned map will throw an on an attempt to insert a key outside of its range, or to construct a submap either of whose endpoints lie outside its range.

  Parameters:
    `fromKey` - low endpoint of the keys in the returned map
    `fromInclusive` - if the low endpoint is to be included in the returned view
    `toKey` - high endpoint of the keys in the returned map
    `toInclusive` - if the high endpoint is to be included in the returned view
  Returns:
    a view of the portion of this map whose keys range from to
  Throws:
    `java.lang.ClassCastException` - if and cannot be compared to one another using this map's comparator (or, if the map has no comparator, using natural ordering). Implementations may, but are not required to, throw this exception if or cannot be compared to keys currently in the map.
    `java.lang.NullPointerException` - if or is null and this map does not permit null keys
    `java.lang.IllegalArgumentException` - if is greater than ; or if this map itself has a restricted range, and or lies outside the bounds of the range

### headMap

    public NavigableMap headMap(java.lang.Object toKey,
                                boolean inclusive)

  Returns a view of the portion of this map whose keys are less than (or equal to, if is true) . The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

  The returned map will throw an on an attempt to insert a key outside its range.

  Parameters:
    `toKey` - high endpoint of the keys in the returned map
    `inclusive` - if the high endpoint is to be included in the returned view
  Returns:
    a view of the portion of this map whose keys are less than (or equal to, if is true)
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this map's comparator (or, if the map has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to keys currently in the map.
    `java.lang.NullPointerException` - if is null and this map does not permit null keys
    `java.lang.IllegalArgumentException` - if this map itself has a restricted range, and lies outside the bounds of the range

### tailMap

    public NavigableMap tailMap(java.lang.Object fromKey,
                                boolean inclusive)

  Returns a view of the portion of this map whose keys are greater than (or equal to, if is true) . The returned map is backed by this map, so changes in the returned map are reflected in this map, and vice-versa. The returned map supports all optional map operations that this map supports.

  The returned map will throw an on an attempt to insert a key outside its range.

  Parameters:
    `fromKey` - low endpoint of the keys in the returned map
    `inclusive` - if the low endpoint is to be included in the returned view
  Returns:
    a view of the portion of this map whose keys are greater than (or equal to, if is true)
  Throws:
    `java.lang.ClassCastException` - if is not compatible with this map's comparator (or, if the map has no comparator, if does not implement `Comparable`). Implementations may, but are not required to, throw this exception if cannot be compared to keys currently in the map.
    `java.lang.NullPointerException` - if is null and this map does not permit null keys
    `java.lang.IllegalArgumentException` - if this map itself has a restricted range, and lies outside the bounds of the range

### subMap

    public java.util.SortedMap subMap(java.lang.Object fromKey,
                                      java.lang.Object toKey)

  Equivalent to .

  Specified by:
    `subMap` in interface `java.util.SortedMap`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException`
    `java.lang.IllegalArgumentException`

### headMap

    public java.util.SortedMap headMap(java.lang.Object toKey)

  Equivalent to .

  Specified by:
    `headMap` in interface `java.util.SortedMap`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException`
    `java.lang.IllegalArgumentException`

### tailMap

    public java.util.SortedMap tailMap(java.lang.Object fromKey)

  Equivalent to .

  Specified by:
    `tailMap` in interface `java.util.SortedMap`
  Throws:
    `java.lang.ClassCastException`
    `java.lang.NullPointerException`
    `java.lang.IllegalArgumentException`

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD